/*
fsome Version 0.2.0 - Match Single Roster Foursome
Copyright (C) 2002-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rnd.h"
#include "tree.h"

#define MAX 900
#define MAXCT 450
#define NE 1
#define NS 2
#define NW 3
#define ES 4
#define EW 5
#define SW 6

int roundtbl[500] = { 0,
   0,0,0,0,4,4,4,5,                /*  16 -  32 */
   5,5,5,5,6,6,6,6,                /*  36 -  64 */
   6,6,6,6,6,6,6,6,                /*  68 -  96 */
   6,6,6,6,7,7,7,7,                /* 100 - 128 */
   7,7,7,7,7,7,7,7,                /* 132 - 160 */
   7,7,7,7,7,7,7,8,                /* 164 - 192 */
   8,8,8,8,8,8,8,8,                /* 196 - 224 */
   8,8,8,8,8,8,8,8,                /* 128 - 256 */
   8,8,8,8,8,8,8,8,                /* 260 - 288 */
   8,8,8,8,8,8,8,9,                /* 292 - 320 */
   9,9,9,9,9,9,9,9,                /* 324 - 352 */
   9,9,9,9,9,9,9,9,                /* 356 - 384 */
   9,9,9,9,9,9,9,9,                /* 388 - 416 */
   9,9,9,9,9,9,9,9,                /* 420 - 448 */
   9,9,9,9,9,9,9,9,                /* 452 - 480 */
   9,9,9,9,9,9,9,9,                /* 484 - 512 */
   10,10,10,10,10,10,10,10,        /* 516 - 544 */
   10,10,10,10,10,10,10,10,        /* 548 - 576 */
   10,10,10,10,10,10,10,10,        /* 580 - 608 */
   10,10,10,10,10,10,10,10,        /* 612 - 640 */
   10,10,10,10,10,10,10,10,        /* 644 - 672 */
   10,10,10,10,10,10,10,10,        /* 676 - 704 */
   11,11,11,11,11,11,11,11,        /* 708 - 736 */
   11,11,11,11,11,11,11,11,        /* 740 - 768 */
   12,12,12,12,12,12,12,12,        /* 772 - 800 */
   12,12,12,12,12,12,12,12,        /* 804 - 832 */
   13,13,13,13,13,13,13,13,        /* 836 - 864 */
   13,13,13,13,13,13,13,13,        /* 868 - 896 */
   13 };

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s players\n", pgm);
   fprintf(stderr,"Where players is divisible by 4\n");
   fprintf(stderr,"and is a number between 20 and %d\n", MAX);
   fprintf(stderr,"Example:  %s 40\n", pgm);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int i,j,indx,rndindx;
   int sortsw;
   int ch;
   int court,north;
   int south,east,west;
   int round,maxround;
   int rostcount,paircount;
   int id;
   int rslt;
   int try,maxtry;
   int rcnthest,rcnthsth,rcnthwst;
   int rceststh,rcestwst,rcsthwst;
   int tmp;
   int totpairs;
   int totplayers;
   int totcourts;
   int  roster[MAX+16];
   prfmt *new;
   prfmt *rth;
   char rndlst[MAXCT*MAXCT][32];

   if (argc != 2) putstx(*argv);
   totplayers = atoi(*(argv+1));
   if (totplayers < 20 || totplayers > MAX) putstx(*argv);
   if (totplayers & 3)
      {
      fprintf(stderr,"Players must be divisible by 4\n");
      putstx(*argv);
      } /* if odd total pairs */
   sd = (unsigned char *) initrnd();
   rth  = (prfmt *) initnode(0,0);
   strcpy(rth->pair,"zzzzzz");
   totpairs = totplayers >> 1;
   totcourts = totpairs >> 1;
   maxround = -999999;
   id = 0;
   while (1) /* group of rounds */
      {
      id++;
      if (rth->left  != NULL) freetree(rth->left);
      rth->left  = NULL;
      rndindx = round = 0;
      while (round < totplayers) /* for each round */
         {
         round++;
         for (i=0;i<totplayers;i++)
            {
            roster[i] = i;
            } /* init roster */
         for (i=totplayers;i<totplayers+1;i++)
            {
            roster[i] = -9999;
            } /* init roster */
         rostcount = totplayers;
         court = 0;
         while (court < totcourts)
            {
            court++;
            paircount = rslt = 0;
            rcnthest = rcnthsth = rcnthwst =
               rceststh = rcestwst = rcsthwst = 1;
            maxtry = rostcount << 7;
            try = 0;
            while ((rcnthest || rcnthsth
               || rcnthwst || rceststh
               || rcestwst || rcsthwst)
               && rostcount > 1
               && try < maxtry)
               {
               try++;
               indx = rndnum(rostcount,sd);
               north = roster[indx];
               while (indx < rostcount)
                  {
                  roster[indx] = roster[indx+1];
                  indx++;
                  } /* shift left */
               rostcount--;
               if (rostcount < 1)
                  {
                  fprintf(stderr,"Out of north\n");
                  exit(1);
                  } /* if out of north */
               indx = rndnum(rostcount,sd);
               east = roster[indx];
               while (indx < rostcount)
                  {
                  roster[indx] = roster[indx+1];
                  indx++;
                  } /* shift left */
               rostcount--;
               if (rostcount < 0)
                  {
                  fprintf(stderr,"Out of east\n");
                  exit(1);
                  } /* if out of east */
               indx = rndnum(rostcount,sd);
               south = roster[indx];
               while (indx < rostcount)
                  {
                  roster[indx] = roster[indx+1];
                  indx++;
                  } /* shift left */
               rostcount--;
               if (rostcount < 0)
                  {
                  fprintf(stderr,"Out of south\n");
                  exit(1);
                  } /* if out of south */
               indx = rndnum(rostcount,sd);
               west = roster[indx];
               while (indx < rostcount)
                  {
                  roster[indx] = roster[indx+1];
                  indx++;
                  } /* shift left */
               rostcount--;
               if (rostcount < 0)
                  {
                  fprintf(stderr,"Out of west\n");
                  exit(1);
                  } /* if out of west */
               /* ascending sort */
               sortsw = 1;
               while (sortsw)
                  {
                  sortsw = 0;
                  if (north > east)
                     {
                     tmp = north;
                     north = east;
                     east = tmp;
                     sortsw = 1;
                     } /* swap */
                  if (east > south)
                     {
                     tmp = east;
                     east = south;
                     south = tmp;
                     sortsw = 1;
                     } /* swap */
                  if (south > west)
                     {
                     tmp = south;
                     south = west;
                     west = tmp;
                     sortsw = 1;
                     } /* swap */
                  } /* sort loop */
               rcnthest = srch(north,east,rth);
               rcnthsth = srch(north,south,rth);
               rcnthwst = srch(north,west,rth);
               rceststh = srch(east,south,rth);
               rcestwst = srch(east,west,rth);
               rcsthwst = srch(south,west,rth);
               if (rcnthest || rcnthsth
                  || rcnthwst || rceststh
                  || rcestwst || rcsthwst)
                  {
                  roster[rostcount++] = north;
                  roster[rostcount++] = east;
                  roster[rostcount++] = south;
                  roster[rostcount++] = west;
                  roster[rostcount] = -9999;
                  } /* if duplicate */
               if (rostcount > totplayers)
                  {
                  fprintf(stderr,"4-way overflow\n");
                  exit(1);
                  } /* overflow */
               } /* assignment loop */
            if (try >= maxtry) break;

            if (!rcnthest && !rcnthsth && !rcnthwst
               && !rceststh && !rcestwst && !rcsthwst)
               {
               new = (prfmt *) initnode(north,east);
               isrt(new,rth,id,round,court,NE);
               new = (prfmt *) initnode(north,south);
               isrt(new,rth,id,round,court,NS);
               new = (prfmt *) initnode(north,west);
               isrt(new,rth,id,round,court,NW);
               new = (prfmt *) initnode(east,south);
               isrt(new,rth,id,round,court,ES);
               new = (prfmt *) initnode(east,west);
               isrt(new,rth,id,round,court,EW);
               new = (prfmt *) initnode(south,west);
               isrt(new,rth,id,round,court,SW);
               sprintf(rndlst[rndindx++],
                  "%03d %03d %03d %03d %03d %03d",
                  round, court,
                  north, east, south, west);
               paircount = 1;
               } /* if successful court */
            else
               {
               break;
               } /* incomplete set */
            } /* for each court in round */
         if (paircount != 1)
            {
            if (round >= roundtbl[totpairs>>1]
               && court >= totcourts)
               {
               for (i=0;i<rndindx;i++)
                  {
                  int len,wrtlen,rslt;
                  char buf[128];
                  sprintf(buf,"%04d %s\n",
                     id, rndlst[i]);
                  len = strlen(buf);
                  wrtlen = write(1,buf,len);
                  if (wrtlen != len)
                     {
                     fprintf(stderr,
                        "Error writing to stdout\n");
                     perror("Write error");
                     exit(1);
                     } /* if write err */
                  } /* for each court in rndlst */
               return(0);
               } /* if bigger round */
            break;
            } /* if failed */
         } /* for each round */
      } /* for each id */
   return(0);
   } /* main */
